package com.wendall 
{
	import com.wendall.events.WendallEvent;
	import com.wendall.views.PreloaderView;
	
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.net.URLRequest;	

	/**
	 * @author bkuzma
	 */
	public class Preloader extends MovieClip 
	{
		private static var PATH_SWF:String = "swf/main.swf";
		private var loader:Loader = new Loader();
		private var view:PreloaderView = new PreloaderView();
		private var main:DisplayObject;
		
		public function Preloader()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
		}
		
		private function onAddedToStage(event:Event):void
		{
			init();
			stage.addEventListener(Event.RESIZE, onResizeStage);
		}
		
		private function init():void
		{
			addChild(view);
			loadSite();
		}
		
		private function loadSite():void
		{
			loader.contentLoaderInfo.addEventListener(Event.INIT, onInit);
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onInit);
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, onLoadProgress);
			loader.load(new URLRequest(PATH_SWF));
		}
		
		private function onLoadProgress(event:ProgressEvent):void
		{
			var progress:Number = Math.floor(event.bytesLoaded / event.bytesTotal);
			view.updateProgress(progress); 
		}

		private function onInit(event:Event):void
		{
			view.addEventListener(WendallEvent.COMPLETE_OUTRO, onCompleteOutro);
			view.outro();
		}
		
		private function onCompleteOutro(event:WendallEvent):void
		{
			main = loader.content;
			loader.unload();
			
			positionSite();
			addChild(main);
		}
		private function onResizeStage(event:Event):void
		{
			positionSite();
		}
		
		private function positionSite():void
		{
			main.x = (stage.stageWidth - 1000) / 2;
			main.y = (stage.stageHeight - 600) / 2;
		}
	}
}
