package com.wendall.controllers 
{
	import com.wendall.views.HomeView;
	
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;		

	/**
	 * @author Brian Kuzma
	 */
	public class HomeController extends SectionController 
	{
		private static const PATH_XML:String = "../xml/quote.xml";
		private var xml:XML;
		private var quotes:Array = new Array();

		public function HomeController()
		{
			super();
		}
		
		override protected function init():void
		{
			view = new HomeView();
			loadXML();
		}
		
		private function loadXML():void
		{
			var loaderXML:URLLoader = new URLLoader();
			loaderXML.load(new URLRequest(PATH_XML));
			loaderXML.addEventListener(Event.COMPLETE, onCompleteXML);
		}
		
		private function onCompleteXML(event:Event):void
		{
			xml = XML(event.currentTarget.data);
			for each (var node:XML in xml.quote)
			{
				quotes.push(node);
			}
			
			initQuote();
		}
		
		private function initQuote():void
		{
			HomeView(view).setQuote(String(quotes[0]).toLocaleUpperCase());
		}
	}
}
