package com.wendall.views 
{
	import gs.TweenLite;
	
	import com.wendall.views.View;
	
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;	

	/**
	 * @author Brian Kuzma
	 */
	public class HomeView extends View 
	{
		private var quote:HomeQuote = new HomeQuote;
		private var quoteCopy:String;
		private var textField:TextField = new TextField();
		private var textFormat:TextFormat = new TextFormat();
		private var fontGotham:GothamBoldItalic = new GothamBoldItalic;

		public function HomeView()
		{
			super();
		}
		
		override protected function init():void
		{
			textField.x = 6;
			textField.y = 7;
			quote.addChild(textField);
			
			quote.x = 216;
			quote.y = 220;
			quote.alpha = 0;
			addChild(quote);
		}
		
		override public function intro():void
		{
			TweenLite.to(quote, .3, {alpha:1, onComplete:onCompleteIntro});
		}

		override public function outro():void
		{
			TweenLite.to(quote, .3, {alpha:0, onComplete:onCompleteOutro});
		}
		
		public function setQuote(_quoteCopy:String):void
		{
			quoteCopy = _quoteCopy;
			textField.text = quoteCopy;
			
			textFormat.font = fontGotham.fontName;
			textFormat.size = 18;
			textField.autoSize = TextFieldAutoSize.LEFT;
			textField.embedFonts = true;
			textField.setTextFormat(textFormat);

			quote.bg.width = textField.x + textField.width + 12;
			trace('textField.width: ' + (textField.width));
			trace('textField.x: ' + (textField.x));
		}
	}
}
