package com.wendall.views 
{
	import gs.TweenLite;
	
	import noponies.display.NpTileBg;
	
	import com.wendall.events.WendallNavEvent;
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;	

	/**
	 * @author Brian Kuzma
	 */
	public class MainView extends View 
	{
		// has background, top nav, logo
		private var tile:Tile = new Tile(6, 6);
		private var bg:NpTileBg;
		private var header:HeaderMain = new HeaderMain;
		private var nav:NavMain = new NavMain;
		private var navButtons:Array;
		
		public function MainView()
		{
			super();
		}
		
		override protected function init():void
		{
			initBackground();
			initNav();
			
			header.x = 55;
			header.y = 53;
			header.alpha = 0;
			addChild(header);
		}
		
		override public function intro():void
		{
			TweenLite.to(header, .3, {alpha:1});
			TweenLite.to(nav, .3, {alpha:1, delay:.3, onComplete:super.intro});
		}
		
		public function addView(view:View, _x:Number = 0, _y:Number = 0):void
		{
			view.x = _x;
			view.y = _y;
			addChild(view);
		}
		
		private function initNav():void
		{
			nav.x = 55;
			nav.y = 94;
			nav.alpha = 0;
			addChild(nav);
			
			navButtons = [nav.buttonHome, nav.buttonBio, nav.buttonNews];
		}

		public function activateNav():void
		{
			for (var i:uint = 0; i < navButtons.length; i++)
			{
				var navButton:Sprite = navButtons[i] as Sprite;
				navButton.addEventListener(MouseEvent.ROLL_OVER, onRollOverNavButton);
				navButton.addEventListener(MouseEvent.ROLL_OUT, onRollOutNavButton);
				navButton.addEventListener(MouseEvent.CLICK, onClickNavButton);
				navButton.buttonMode = true;
			}
		}
		
		public function deactivateNav():void
		{
			for (var i:uint = 0; i < navButtons.length; i++)
			{
				var navButton:Sprite = navButtons[i] as Sprite;
				navButton.removeEventListener(MouseEvent.ROLL_OVER, onRollOverNavButton);
				navButton.removeEventListener(MouseEvent.ROLL_OUT, onRollOutNavButton);
				navButton.removeEventListener(MouseEvent.CLICK, onClickNavButton);
				navButton.buttonMode = false;
			}
		}
		
		private function onClickNavButton(event:MouseEvent):void
		{
			var navEventString:String;
			switch (Sprite(event.target).name)
			{
				case "buttonHome":
					navEventString = WendallNavEvent.HOME;
					break;
				case "buttonBio":
					navEventString = WendallNavEvent.BIO;
					break;				
				case "buttonNews":
					navEventString = WendallNavEvent.NEWS;
					break;				
			}
			
			dispatchEvent(new WendallNavEvent(navEventString, WendallNavEvent.CLICK_NAV));
		}

		private function onRollOutNavButton(event:MouseEvent):void
		{
		}

		private function onRollOverNavButton(event:MouseEvent):void
		{
		}

		private function initBackground():void
		{
			bg = new NpTileBg(tile);
			addChild(bg);
		}
	}
}
